qx.Class.define( "rap.tinymce.core.TinyMCE", {
	extend : qx.ui.embed.Iframe,

	events : {
		"editor-ready" : "qx.event.type.Event"
	},

	construct : function(id, htmlfile) {
		this.base(arguments);
		this.setHtmlAttribute("id", id);
		this._id = id;
		this.addEventListener("changeHeight", this._doResize, this);
    	this.addEventListener("changeWidth", this._doResize, this);
    	
    	qx.ui.embed.Iframe.call(this, htmlfile);

    	with (this) {
        	setFrameName("tinymce" + this.toHashCode());
        	setOverflow("hidden");
    	}
    	
    	
    	this.addEventListener("appear", function() {
    		var timer = new qx.client.Timer(50);
    		timer.addEventListener("interval", function(e) {
    			if (this.getIframeWindow() && this.getIframeWindow().tinyMCE != null && this.getIframeWindow().tinyMCE.get('tarea') != null  ) {
    				timer.stop();
    				//this.getIframeWindow().setParentWidget(this); //not a function !?
    				this.getIframeNode().style.overflow = "hidden";
    				
    				var obj = this;
    				this.getIframeWindow().tinyMCE.get('tarea').onChange.add(function() {
    					if( !org_eclipse_rap_rwt_EventUtil_suspend ) {
    						var wm = org.eclipse.swt.WidgetManager.getInstance();
    						var req = org.eclipse.swt.Request.getInstance();
    						req.addParameter( wm.findIdByWidget(obj) + ".precontent", this.getContent() );
    						req.send();
    					}
    				});
    				
    				this.createDispatchEvent("editor-ready");
    			}
    		}, this);
    		
    		timer.start();
    	});
    	    	
	},
	
	properties : {
		  
	    // Dummy property to make it works with RAP 1.3
	    backgroundGradient : {
	      check : "Array",
	      nullable : true,
	      init : null,
	      themeable : true
	    },

		precontent : {
			apply : "_setPrecontent"
		}
	},
	
	members : {
		
		_setPrecontent : function(value, old) {
			var timer = new qx.client.Timer(50);
			timer.addEventListener("interval", function(e) {
				if (this.getIframeWindow() && this.getIframeWindow().tinyMCE != null && this.getIframeWindow().tinyMCE.get('tarea') != null ) {
				//if (this.getIframeWindow() && this.getIframeWindow().document.getElementById("tarea") != null ) {
					timer.stop();
					this.getIframeWindow().tinyMCE.get('tarea').setContent(value);
					this.getIframeWindow().document.getElementById("tarea").value = value;
					
					if( !org_eclipse_rap_rwt_EventUtil_suspend ) {
						var wm = org.eclipse.swt.WidgetManager.getInstance();
						var req = org.eclipse.swt.Request.getInstance();
						req.addParameter( wm.findIdByWidget(this) + ".precontent", this.getIframeWindow().tinyMCE.get('tarea').getContent() );
						req.send();
					}
					
				}
			}, this);

			timer.start();
		},
		
		getIframeWindow : function() {
			var ifnode = this.getIframeNode();
			if (ifnode == null) return false;
		    
			if (typeof ifnode == "object" 
				&& typeof ifnode.contentWindow == "object") {
				return ifnode.contentWindow;
			} else {
				return false;
			}
		},
		
		_doResize : function() {
			qx.ui.core.Widget.flushGlobalQueues();
		}
	}
});