package rap.tinymce;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.ui.forms.AbstractFormPart;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.forms.editor.FormPage;

import rap.tinymce.core.TinyMCE;

public class EditorPage extends FormPage {

	private AbstractFormPart formPart;

	public EditorPage(FormEditor editor) {
		super(editor, "EditorPage", "Page"); //$NON-NLS-1$//$NON-NLS-2$
	}

	@Override
	protected void createFormContent(IManagedForm mForm) {

		getManagedForm().getForm().setLayoutData(
				new GridData(SWT.FILL, SWT.FILL, true, true));
		Composite formBody = getManagedForm().getForm().getBody();
		formBody.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		GridLayout layout = new GridLayout(1, false);
		layout.horizontalSpacing = 0;
		layout.verticalSpacing = 0;
		formBody.setLayout(layout);

		formPart = new AbstractFormPart() {
		};
		getManagedForm().addPart(formPart);

		TinyMCE tinyMce = new TinyMCE(formBody, SWT.NONE,
				"tiny_mce/tinymce.html", new Listener() {

					@Override
					public void handleEvent(Event event) {
						formPart.markDirty();
						System.out.println("marked dirty");
					}
				});
		GridData gd_tinymce = new GridData(SWT.FILL, SWT.FILL, true, true);
		tinyMce.setLayoutData(gd_tinymce);

		formBody.layout();
	}

}
