package rap.tinymce.internal.core.tinymcekit;

import java.io.IOException;

import org.eclipse.rwt.lifecycle.AbstractWidgetLCA;
import org.eclipse.rwt.lifecycle.ControlLCAUtil;
import org.eclipse.rwt.lifecycle.IWidgetAdapter;
import org.eclipse.rwt.lifecycle.JSWriter;
import org.eclipse.rwt.lifecycle.WidgetLCAUtil;
import org.eclipse.rwt.lifecycle.WidgetUtil;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Widget;

import rap.tinymce.core.TinyMCE;

public class TinyMCELCA extends AbstractWidgetLCA {

	private static final String JS_PROP_CONTENT = "precontent";
	private static final String PROP_CONTENT = "precontent";
	
	@Override
	public void preserveValues(Widget widget) {
		System.out.println("preserveValues (" + widget + ")");
		
		ControlLCAUtil.preserveValues( ( Control )widget );
	    IWidgetAdapter adapter = WidgetUtil.getAdapter( widget );
	    
	    String content = ((TinyMCE) widget).getContent();
	    System.out.println("   PV content=(" + content + ")");
	    if ( content != null ) {
	    	adapter.preserve(PROP_CONTENT, content);
	    }
	    System.out.println();
	    
	    WidgetLCAUtil.preserveCustomVariant(widget);
	}

	@Override
	public void renderChanges(Widget widget) throws IOException {
		System.out.println("renderChanges (" + widget + ")");
		
		TinyMCE tinyMce = (TinyMCE) widget;
		ControlLCAUtil.writeChanges(tinyMce);
		System.out.println("   RC content =(" + tinyMce.getContent() + ")");
		if ( tinyMce.getContent() != null ) {
			JSWriter writer = JSWriter.getWriterFor(widget);
			writer.set(PROP_CONTENT, JS_PROP_CONTENT, tinyMce.getContent());
		}

		WidgetLCAUtil.writeCustomVariant(widget);
		
	}

	@Override
	public void renderDispose(Widget widget) throws IOException {
		System.out.println("renderDispose (" + widget + ")");
		JSWriter writer = JSWriter.getWriterFor(widget);
		writer.dispose();
	}

	@Override
	public void renderInitialization(Widget widget) throws IOException {
		System.out.println("renderInitialization (" + widget + ")");
		JSWriter writer = JSWriter.getWriterFor(widget);
		String id = WidgetUtil.getId(widget);
		writer.newWidget("rap.tinymce.core.TinyMCE", new Object[]{ id, ((TinyMCE)widget).getHtmlFile() });
		writer.set("appearance", "composite");
	    writer.set("overflow", "hidden");
		ControlLCAUtil.writeStyleFlags((TinyMCE)widget);
	}

	@Override
	public void readData(Widget widget) {
		System.out.println();
		System.out.println("readData (" + widget + ")");
		
		TinyMCE tinyMce = (TinyMCE) widget;
	    String content = WidgetLCAUtil.readPropertyValue(tinyMce, PROP_CONTENT);
	    
	    System.out.println("   RD content=(" + content + ")");
	    
	    if ( content != null ) {
		    tinyMce.setContent(content);
	    }
	    
	}

}
